/*=============================*/
/*== Application web Node.js ==*/
/*=============================*/

/** Avant de lancer ce script avec "node website.js",
 *  remplissez la variable d'environnement NODE_ENV *
/** Commande : "SET NODE_ENV=dev"

/** L'adresse de démarrage est par défaut : http://localhost:82/ **/

var
/*== Charger les modules Node.js ==*/
	http = require("http"),
	express =  require("express"), /* npm install express */
	httpServer = express(),
	MemoryStore = express.session.MemoryStore,

	jsdom = require("jsdom").jsdom, /* npm install jsdom */
	jquery = require('jquery'), /* npm install jquery */

/*== Variables globales de l'application ==*/
	appConfig = {};

/*== Paramétrage de l'application ==*/

httpServer
/* == Définir un environnement d'exécution : SET NODE_ENV=dev ==*/
	.configure(function () {
		/* Commun à tous les environnements */

		/* Permettre la récupération de variable en POST via request.body */
		httpServer.use(express.bodyParser());

		/* Permet la manipulation des cookies de session */
	    httpServer.use(express.cookieParser());

	    /* Gabari d'un cookie de session */
	    httpServer.use(express.session({
        	store: new MemoryStore(), /* Espace de stockage */
        	secret: 'secret', /* Empècher la falscification */
        	key: 'website.sid' /* Nom du cookie */
	    }));
	})
	.configure("dev", function () {
		/* Uniquement en environnement de Dev */
		appConfig.host = "localhost";
		appConfig.path = "/";
		appConfig.httpPort = 82;
		appConfig.url = appConfig.host + ((appConfig.httpPort != 80) ? ":" + appConfig.httpPort : "") + appConfig.path;
	})
	.configure("test", function () {
		/* Uniquement en environnement de Test */
	})
	.configure("qual", function () {
		/* Uniquement en environnement de Qualité */
	})
	.configure("prod", function () {
		/* Uniquement en environnement de Production */
	}).listen(appConfig.httpPort);

/*********************************************/
/*** Chemins de réponse - Réécriture d'url ***/
/*********************************************/

/* Accueil */
// http://www.site.com/
httpServer.get(appConfig.path, function (request, response) {
	var
		header = {
			"Content-Type": "text/html",
			"Charset": "utf-8"
		},


	// Partie Vue.
		document = jsdom('<!DOCTYPE html>' +
			'<html>' +
				'<head>' +
					'<meta charset="utf-8" />' +
					'<title>Ma première page</title>' +
					'<base href="//' + appConfig.url + '" />' +
				'</head>' +
				'<body>' +
					"<p><a href='./connexion/' title='Page de connexion'>Page de connexion</a></p>" +
				'</body>' +
			'</html>'),
		window = document.createWindow(),
		jQuery = jquery.create(window),
		$ = jQuery,

	// Partie Contrôle.
	h1Title = $("<h1>").text("Ceci est le titre d'origine !");
	$("body").prepend(h1Title);

	if (1 == 1) {
		h1Title = $("h1").text("Ceci est le titre changé !");
	}



	// Partie Rendu.
	response.writeHead(200, header);
	response.write(window.document.innerHTML);
	response.end();
});

/* Connexion */
// http://www.site.com/connexion/
function connectionRender(request, response) {
	var
		header = {
			"Content-Type": "text/html",
			"Charset": "utf-8"
		},

		document = jsdom('<!DOCTYPE html>' +
			'<html>' +
				'<head>' +
					'<meta charset="utf-8" />' +
					'<title>Page de connexion</title>' +
					"<base href='//" + appConfig.url + "' />" +

					'<style text="text/css">' +
						'.error {' +
							'display: none;' +
						'}' +
						'.error.show {' +
							'display: block;' +
						'}' +
						'.error span {' +
							'display: none;' +
							'color: #ff0000;' +
						'}' +
						'.show span.show {' +
							'display: block;' +
						'}' +
					'</style>' +

				'</head>' +
				'<body>' +
					'<form id="login" action="./connexion/" method="POST">' +
						'<div class="field-login-email">' +
							'<label for="login-email" placeholser="Email">Email : </label>' +
							'<input id="login-email" type="text" name="login[email]" />' +
							'<div class="error">' +
								'<span class="empty">Le champ email est vide.</span>' +
								'<span class="invalide">Le champ email est invalide.</span>' +
							'</div>' +
						'</div>' +

						'<div class="field-login-password">' +
							'<label for="login-password" placeholser="Mot de passe">Mot de passe : </label>' +
							'<input id="login-password" name="login[password]" type="password" />' +
							'<div class="error">' +
								'<span class="empty">Le champ mot de passe est vide.</span>' +
								'<span class="invalide">Le couple Email/Mot de passe est incorrecte !</span>' +
							'</div>' +
						'</div>' +

						'<label><input type="submit" value="Ok" /></label>' +
					'</form>' +
					'<div id="logged">Vous êtes passé !</div>' +
				'</body>' +
			'</html>'),
		window = document.createWindow(),
		jQuery = jquery.create(window),
		$ = jQuery;


		// Si on passe par ici après une réclamation en POST, on entre.
		if (request.method == 'POST') {
			var
				// Par défaut, on estime que la validation du formulaire est bonne.
				isValid = true,
				// Normalement, cet info se récupère dans une base de donnée. C'est un des utilisateurs valide.
				passEmail = "tout@est.ok",
				// Et ça c'est le mot de passe associé à l'utilisateur.
				passPassword = "azerty",
				// Une regex pour vérifier la validité des emails.
				checkEmail = /^[-._a-z0-9]+@[-._a-z0-9]+\.[.a-z]{2,4}$/i;

			// Quoi qu'il arrive on réinjecte la valeur email.
			$("#login-email").val(request.body.login.email.trim());

				
			// Le champ email est-il remplit ?
			if (request.body.login.email.trim() == "") {
				// S'il est vide, on le signale.
				$(".field-login-email .error").addClass("show");
				$(".field-login-email .error .empty").addClass("show");
				// Et on ne valide pas le formulaire.
				isValid = false;

			// Le champ email est-il valide ?
			} else if (!checkEmail.test(request.body.login.email.trim())) {
				// S'il est anormal, on le signale.
				$(".field-login-email .error").addClass("show");
				$(".field-login-email .error .invalide").addClass("show");

				// Et on ne valide pas le formulaire.
				isValid = false;
			}

			// Le champ mot de passe est-il remplit ?
			if (request.body.login.password.trim() == "") {
				// S'il est vide, on le signale.
				$(".field-login-password .error").addClass("show");
				$(".field-login-password .error .empty").addClass("show");
				// Et on ne valide pas le formulaire.
				isValid = false;
			}

			if (isValid) {
				// Y a t-il une concordance email / mot de passe.
				if (
					request.body.login.email.trim() == passEmail &&
					request.body.login.password.trim() == passPassword
				) {

					// En passant ici on initialise l'état d'utilisateur identifié.
					request.session.user = request.session.user || {};
					request.session.user.isLogged = true;

				} else {
					// S'il y a une erreur, on le signale.
					$(".field-login-password .error").addClass("show");
					$(".field-login-password .error .invalide").addClass("show");
				}
			}
		}

		// Si il y a un objet user avec la propriété isLogged à true.
		if (request.session.user && request.session.user.isLogged) {
			// On retire la partie hors-connexion.
			$("#login").remove();
		} else {
			// On retire la partie connexion.
			$("#logged").remove();
		}

	response.writeHead(200, header);
	response.write(window.document.innerHTML);
	response.end();	
}
httpServer.get(appConfig.path + "connexion", function (request, response) {
	connectionRender(request, response);
}).post(appConfig.path + "connexion", function (request, response) {
	connectionRender(request, response);
});

/* Si aucune page ne match */
httpServer.use(httpServer.router);
httpServer.use(function(request, response, next) {
	var
		header = {
			"Content-Type": "text/html",
			"Charset": "utf-8"
		},
		document = jsdom('<!DOCTYPE html>' +
			'<html>' +
				'<head>' +
					'<meta charset="utf-8" />' +
					'<title>Page de connexion</title>' +
					"<base href='//" + appConfig.url + "' />" +
				'</head>' +
				'<body>' +
					"<p>Cette page n'existe pas.</p>" +
				'</body>' +
			'</html>'),
		window = document.createWindow();

	response.writeHead(404, header);
	response.write(window.document.innerHTML);
	response.end();
});
